---
layout: default
title: Урок №9. Добавляем модуль форума на сайт
nav_order: 9
parent: Быстрый старт, уроки для разработчиков
grand_parent: Руководство разработчика
---

# Урок №9. Добавляем модуль форума на сайт

На примере темы «Корпоративный сайт».

Прежде всего необходимо установить модуль «Форум»:

![Пример]({{site.baseurl}}/images/2017-05-06-17-04-15.png)

При установке модуль создает корневой раздел форума «forum» в котором будут располагаться разделы форума. И служебный раздел «forum-post» в котором будут располагаться комментарии форума. Управление этими разделами доступно пользователям входящим в группы «Администраторы», «Модераторы форума».

После установки, в публичной части форум доступен по адресу http://<ваш-сайт>/forum/. Изначально в форуме отсутствуют разделы и темы. Вы можете создать нужные разделы и темы в них используя инструкцию.

![Пример]({{site.baseurl}}/images/2017-05-06-225727.png)

Чтобы изменить внешний вид форума добавьте собственные шаблоны для виджетов форума. Чтобы изменить параметры виджета форума Forum.Category, создайте собственный контроллер и укажите его в настройках главного раздела форума.

Создание собственного контроллера:

* введите название контроллера (1), например page_forum.twig;
* нажмите на иконку создания/редактирования контролера (2);
* внесите в поле редактирования код соответствующий вашим потребностям и сохраните изменения.

![Пример]({{site.baseurl}}/images/2017-05-06-234334.png)

Код представленный на скриншоте.

```
{% raw %}{# расширяем главный шаблон темы #}
{% extends layout %}

{% block main %}

    {# добавляем виджет форума и задаем нужные параметры #}
    {% widget 'Forum.Category' with { css_class: 'content', forum_catalog: catalog.path.2, list_limit: 10 } %}

{% endblock %}{% endraw %}
```

Изменить шаблоны виджетов можно в административной части сайта во вкладке Шаблоны виджетов. Выберите шаблон нужного виджета, внесите изменения, и сохраните новый шаблон выбрав тему сайта и указав название шаблона.

## Возможности незарегистрированных и зарегистрированных пользователей

*Незарегистрированный пользователь имеет возможность*:

* читать материалы форума;
* добавлять комментарии к темам форума не регистрируясь (необходимо ввести свое имя в поле 1 - «*Ваше имя для комментария*».

![Пример]({{site.baseurl}}/images/2017-05-06-193326.png)

Зарегистрированный пользователь имеет возможность:

* читать материалы форума;
* комментировать темы форума под своим именем (вводить имя не нужно);

![Пример]({{site.baseurl}}/images/2017-05-06-191355.png)

создавать новые темы, заполнив поля 1 и 2.

![Пример]({{site.baseurl}}/images/2017-05-06-19-02-04-.png)

## Возможности модератора форума

В публичном разделе форума модератору доступны все возможности зарегистрированного пользователя.

В административном разделе модератор может управлять структурой и ***материалами форума***: создавать/изменять/удалять разделы, темы и комментарии форума.

Для управления форумом через административный раздел необходимо:

* авторизоваться в административном разделе под учетной записью с правами модератора форума;
* в области ***Сайты*** выбрать нужный раздел ***форума*** (1), нажать на поле ***Материалы*** (2) в области ***Навигация***.
В рабочей области (3) расположены материалы форума.

![Пример]({{site.baseurl}}/images/2017-05-06-193821.png)
 
### Модерирование раздела «Форум»

1. Создание новой Категории/Подраздела

* выберите родительский раздел (1) и нажмите кнопку ***Новый раздел*** (2) на контекстной панели;
* заполните поле ***Имя*** и ***Alias*** в форме. ***Тип материалов*** не меняйте. ***Ок***;

![Пример]({{site.baseurl}}/images/2017-05-06-194333.png)

* откройте свойства созданного раздела и выберите пункт «**ID материала**».

![Пример]({{site.baseurl}}/images/2017-05-06-195318.png)

2. Создание новой ***Темы***

***создайте*** новый материал (1) (***Создать по образцу*** — кнопка рядом);
в форме, заполните поля во вкладках ***Свойства***, ***Описание*** (поле ***Alias*** заполняется автоматически);
сохраните материал (при нажатии на кнопку *Сохранить и опубликовать* — материал будет сразу опубликован на сайте)

![Пример]({{site.baseurl}}/images/2017-05-06-194733.png)

3. Редактирование ***Темы***

выберите интересующий материал, нажать кнопку ***Изменить***;
внесите корректировки. ***Сохранить***.

4. Удаление ***Темы***

выберите материал в рабочей области, нажать кнопку ***Удалить***.

### Модерирование раздела «Комментарии форума»

* выберите материал в разделе Комментарии форума, нажмите на кнопку ***Редактировать*** (1);
* измените значение свойств материала во вкладке ***Свойства*** и ***Текст*** (2). Кнопка ***показать на сайте*** - если дата публикации в будущем, то по умолчанию материал не будет показан на сайте, если отметить этот чекбокс — то будет;
* после внесенных корректировок — ***Сохранить***.

![Пример]({{site.baseurl}}/images/2017-05-06-195113.png)