---
layout: default
title: Модуль «Торговля»
nav_order: 7
parent: Плагины (модули) Cetera CMS
grand_parent: Руководство разработчика
---

# Модуль «Торговля»

Добавляет возможность продажи товаров на сайте.

При установке модуль добавляет тип материалов «sale_products», в котором хранятся товары.

* Для работы с товарами используется класс \Sale\Product, расширяющий \Cetera\Material
* Для работы с корзиной используется класс \Sale\Cart
* Для работы с заказами используется класс \Sale\Order

## Класс \Sale\Cart

Метод | Описание
---|---
**get()**|Статический метод. Возвращает корзину текущего пользователя.
**setProduct( $product, $quantity = 1 )**|Установить количество товара в корзине. $quantity = 0 — удалить из корзины
**addProduct( $product, $quantity = 1 )**|Добавить товар в корзину в указанном количестве.
**getProducts()**|Получить товары в корзине.
**getProductsCount()**|Кол-во товаров корзине.
**getTotal()**|Стоимость товаров в корзине.
**clear()**|Очистить корзину.
**delete()**|Удалить корзину.

## Класс \Sale\Order

Метод | Описание
---|---
**enum()**|Статический метод. Список всех заказов. Возвращает \Sale\Iterator\Order наследник \Cetera\Iterator\DbObject
**make($cart)**|Статический метод. Создает заказ на основе корзины
**getById($id)**|Статический метод. Ищет заказ по ID
**getId()**|ID заказа
**getProducts()**|Получить товары в заказе.
**getTotal()**|Стоимость заказа с учетом доставки.
**getProductsCost()**|Стоимость только товаров заказа.
**save()**|Сохранить заказ в БД.

## Виджет Sale.Goods.List

Показывает список товаров

### Пример вызова Twig

	{% raw %}{% widget 'Comments.Add' with { material: article } %}{% endraw %}

Параметр | Описание
---|---
**template**|Шаблон вывода

## Виджет Sale.Goods.Item

Показывает одиночный товар

Параметр | Описание
---|---
**template**|Шаблон вывода

## Виджет Sale.Cart.Line

Показывает информацию о состоянии корзины

Параметр | Описание
---|---
**template**|Шаблон вывода

## Виджет Sale.Cart

Показывает содержимое корзины, позволяет изменять товары.

Параметр | Описание
---|---
**template**|Шаблон вывода
**order_url**|URL страницы оформления заказа. По умолчанию "**/order/**"
**catalog_url**|URL главной страницы каталога продукции. По умолчанию **false**
**show_coupon**|Показать форму для ввода скидочных купонов. По умолчанию **false**

## Виджет Sale.Order

Оформление заказа.

Параметр | Описание
---|---
**template**|Шаблон вывода