---
layout: default
title: Calendar
nav_order: 4
parent: Виджеты
grand_parent: Руководство разработчика
---

# Calendar

Показывает календарь. Ссылки на дни в календари активны в случае, если за это день есть материалы в выбранном разделе сайта.

*CeteraCMS 3.22+*

## Пример вызова в PHP

	\Cetera\Application::getInstance()->getWidget('Calendar', array(
	    'ajax' => true,
	))->display();
 
## Пример вызова в Twig

	{% raw %}{% widget 'Calendar' with { ajax: 1 } %}{% endraw %}

## Описание параметров

Параметр | Описание
---|---
template|Шаблон вывода
catalog|Раздел сайта. По умолчанию —  текущий раздел
subsections|`true|false` Проверять подразделы. По умолчанию *true*
date|Текущая дата. Если не указана, дата берется из $_REQUEST, ключ задается параметром **date_param**
date_param|Ключ в массиве $_REQUEST из которого берется текущая дата. По умолчанию *date*
day_url|Шаблон ссылок, которые вешаются на активные дни в календаре, т.е. те дни, за которые существуют материалы в разделе. {date_param} заменяется на значение параметра date_param, {date} заменяется на дату. По умолчанию *?{date_param}={date}*
month_url|Шаблон ссылок, которые вешаются на месяцы в календаре. {date_param} заменяется на значение параметра date_param, {date} заменяется на дату. По умолчанию *?{date_param}={date}*
ajax|`true|false` AJAX-режим: переключение месяцев без перезагрузки . По умолчанию *false*