---
layout: default
title: List.Sections
nav_order: 18
parent: Виджеты
grand_parent: Руководство разработчика
---

# List.Sections

Выводит список подразделов в заданном количестве и в заданной последовательности.

## Пример вызова PHP

	\Cetera\Application::getInstance()->getWidget('List', array(
	    'catalog'   => 0,
	    'limit'     => 5,
	    'order'     => 'dat',
	    'sort'      => 'DESC',
	    'paginator' => true,
	))->display();

## Пример вызова Twig

	{% raw %}{% widget 'List.Sections' with { limit:6, paginator:1, template: 'tiles.twig' } %}{% endraw %}

## Описание параметров

Параметр | Описание
---|---
**template**|Шаблон вывода
**css_class**|Класс, который будет прописан у корневого элемента в шаблоне виджета
**catalog**|Раздел, из которого выводить подразделы. 0 — для текущего раздела. По умолчанию **0**
**limit**|Ограничение кол-ва подразделов. 0 — без ограничения. По умолчанию **10**
**page**|№ страницы, если используется ограничение кол-ва подразделов. По умолчанию **1**
**order**|Поле, по которому сортировать подразделы. По умолчанию **dat** - дата создания раздела. Для сортировки в том порядке, в котором разделы показаны в backoffice, используйте поле **tag**
**sort**|`[ASC|DESC]` Порядок сортировки. По умолчанию **DESC**
**where**|Фильтр подразделов. В SQL запрос добавляется условие указанное условие **WHERE**
**iterator**|Объект \Cetera\Iterator\Catalog по списком подразделов
**paginator**|`[true|false]` Показать постраничную навигацию. По умолчанию **false**
**paginator_template**|Шаблон виджета постраничной навигации
**ajax**|`[true|false]` AJAX-навигация по страницам. По умолчанию **false**
**infinite**|`[true|false]` Режим бесконечной подгрузки страниц. Работает при включенной опции ajax. Используется шаблон постраничной навигации infinite.twig, если не задан другой в параметре paginator_template
**catalog_link**|Показать ссылку на раздел. По умолчанию **false**

## Встроенные шаблоны

Название | Описание
---|---
default.twig|Выводит названия подразделов в виде блоков DIV. **Шаблон по умолчанию**
tiles.twig|Выводит материалы в виде плитки по 3 в строку (паттерн Block Grid в Foundation 6) с выравниванием высоты. [http://foundation.zurb.com/sites/docs/grid.html#block-grids](http://foundation.zurb.com/sites/docs/grid.html#block-grids)
menu.twig|Выводит названия подразделов в виде маркированного списка UL