---
layout: default
title: Search
nav_order: 13
parent: Виджеты
grand_parent: Руководство разработчика
---

# Search

Виджет реализует готовую страницу поиска по сайту.

*CeteraCMS 3.22+*

## Пример вызова в PHP

	\Cetera\Application::getInstance()->getWidget('Search', array(
	    'morphology' =>* true*
	))->display();

## Пример вызова в Twig

	{% raw %}{% widget 'Search' with { morphology: 1 } %}{% endraw %}

## Описание параметров

Параметр | Описание | Замечание
---|---|---
**template**|Шаблон вывода
**type**|ID типа материалов, по которым производить поиск. По умолчанию 1 (Встроенный тип «Материалы»)|С версии 3.29.5 можно указывать несколько типов в виде массива
**min_length**|Минимальная длина слова. По умолчанию 3
**sections**|Массив или строка через «,» идентификаторов разделов, в которых производить поиск. По умолчанию — текущий сервер
**search_subsections**|`true|false` Искать ли в подразделах, указанных в параметре sections разделов. По умолчанию* true*
**morphology**|`true|false` Искать по словоформам слов из поискового запроса. По умолчанию* false*
**fields**|Список полей материалов, в которых производить поиск. По умолчанию «name, text, short»
**query_param**|Параметр формы, через который передается поисковая фраза. По умолчанию «query»
**query_placeholder**|Подсказка в поле ввода поисковой фразы. По умолчанию «Введите строку для поиска»
**button_text**|Надпись на кнопке поиска. По умолчанию «Искать»
**page_param**|Параметр, в котором передается номер страницы. По умолчанию «page»
**page_number**|Номер страницы результатов поиска. По умолчанию — номер, переданный в параметре **page_param**
**items_per_page**|Количество результатов на странице. По умолчанию 20
**sort_field**|Поле сортировки результатов. По умолчанию «dat»
**sort_direction**|`ASC|DESC` Порядок сортировки результатов. По умолчанию «**DESC**»
**paginator_url**|Шаблон ссылок постраничной навигации. По умолчанию «?{query}&page={page}»
**paginator_template**|Шаблон для блока страничной навигации (виджет Paginator)
**show_date**|`true|false` Показывать дату материалов в списке. По умолчанию* true*
**date_format**|Формат даты. По умолчанию «d.m.Y»
**show_path**|`true|false` Показывать путь к материалу. По умолчанию* true*
**path_template**|Шаблон для блока «Путь к материалу» (виджет Breadcrumbs)
**where**|Фильтр материалов. В SQL запрос добавляется указанное условие в блок WHERE|С версии 3.44.10