---
layout: default
title: Баннеры
nav_order: 2
parent: Плагин «Баннерная система»
grand_parent: Руководство пользователя
---

# Баннеры

Баннер представляет собой произвольный фрагмент HTML кода, что позволяет использовать любое представление рекламных материалов: растровая графика, текст, flash.

Подсчёт количества показов и кликов происходит автоматически.

![Пример]({{site.baseurl}}/images/p-3.png)

Свойства баннеров:

1. *Имя* — название баннера, не более 128 символов, например «Баннер Intel»;

2. *Активный* — флаг активности баннера.

3. *Группа* — принадлежность баннера к группе;

4. *Рекламодатель* — принадлежность к рекламодателю;

5. *URL перехода* — ссылка, на которую отправляется пользователь, нажавший на баннер. Баннер может иметь более одной ссылки для перехода. Для того, чтобы добавить новый URL, нажмите кнопку «Добавить». Для того, чтобы удалить URL, нажмите на кнопку «Удалить».

6. *Показывать с… по…* — даты начала и окончания показов баннера. Если установлена, то баннер не будет участвовать в ротации вне указанного промежутка дат;

7. *«Вес» баннера* — величина, определяющая насколько часто будет показываться баннер относительно других баннеров в группе.

8. *Всего показов* — Общее количество показов баннера с момента создания, неизменяемое свойство;

9. *Ограничение показов* — максимальное количество показов баннера. Если установлено, то баннер автоматически исключается из ротации после заданного числа показов;

10. *Всего кликов* — Общее количество кликов по баннеру с момента создания, неизменяемое свойство;

11. *Ограничение кликов* — максимальное кликов по баннеру. Если установлено, то баннер автоматически исключается из ротации после заданного числа кликов;

12. *Лимит показов пользователю* — если этот флаг установлен, то баннер будет показываться одному и тому же посетителю сайта не более заданного количества раз в сутки;

13. *Очередь* — приоритет баннера в группе. При выборе баннера из группы для показа, сначала просматриваются баннеры первой очереди. Если среди баннеров первой очереди ни один не выбран (например, часть баннеров неактивна, другая часть попадает под ограничение по дате), то происходит выбор среди баннеров второй очереди и так далее.

14. *HTML код* — Содержание баннера в виде HTML кода. Определяет внешний вид баннера. В тексте допускаются следующие коды:

	1. *{target}* — при показе баннера на сайте заменяется на «URL перехода». Используйте этот код, вместо явного указания ссылки, в противном случае статистика нажатий на этот баннер будет отображаться неправильно. Если баннер содержит несколько «URL перехода», используйте {target1}, {target2}, ... {targetN}.

	2. *{random}* — при показе баннера на сайте заменяется на случайное число.

	Система может сама сгенерировать HTML код баннера. Для этого нажмите кнопку «Выбрать». Откроется диалоговое окно с файловой структурой сервера. Выберете файл, который вы хотите использовать в качестве баннера, это может быть изображение в формате JPEG, GIF, PNG или Flash-ролик и нажмите кнопку «OK». Подробнее о работе с файловой системой сервера, о закачке своих файлов можно прочитать в главе разделе «[Добавление иллюстраций]({{site.baseurl}}/docs/user-guide/content/vis-1.html)» главы 4 «[Работа с материалами сайта]({{site.baseurl}}/docs/user-guide/content)».

15. Ограничение показа. Имеется возможность ограничить появление баннера определенными странами. Для этого:

	1. на закладке «Ограничение показа» отметьте «показывать этот баннер только посетителям из стран:»;

	2. с помощью кнопки «Добавить» добавьте страны, посетителям из которых нужно показывать баннер.