---
layout: default
title: Публикация нового материала
nav_order: 2
parent: Работа с материалами сайта
grand_parent: Руководство пользователя
---

# Публикация нового материала

Для того, чтобы опубликовать новый материал сайта, пожалуйста, проделайте следующие шаги:

1. В левом верхнем окне (фрейме) «Навигация», выберите пункт «Материалы», либо выберите пункт меню «Сайт->Материалы».

2. В нижнем левом фрейме выберите раздел сайта, в который вы хотели бы опубликовать материал, установив на него курсор. Если вы хотите опубликовать материал в новый раздел, узнать, как можно создавать новые разделы можно в разделе «[Работа со структурой сайта]({{site.baseurl}}/docs/user-guide/structure)».

	![Пример]({{site.baseurl}}/images/cp-cp-1.png)

3. После того, как вы увидите в центральном окне загрузившийся список материалов данного раздела, нажмите на кнопку «Новый материал» на панели инструментов.

4. В браузере откроется новое диалоговое окно. В этом окне вы можете ввести содержание данного материала.

	![Окно «Материал»]({{site.baseurl}}/images/cp-cp-2.png)

	Независимо от типа, у каждого материала всегда присутствуют три поля:

5. Начните работу по заполнению полей материала. Количество и названия заполняемых полей зависят от типа создаваемого вами материала. Типы материалов определяются и утверждаются на этапе проектирования сайта.

	Замечание
	Поле alias может состоять только из латинских букв и цифр, а также знака «\_».

	1. Заголовок — содержит заголовок материала;

	2. *Алиас* — сокращенное название материала. В основном он нужен для того, что URL материала на сайте имел осмысленный вид (например: http://www.сервер/алиас_раздела/алиас_материала.html). Кроме того, алиас может произвольно использоваться при программировании шаблонов. Например, по алиасу могут быть связаны технические характеристики товаров, продвигаемых компанией, и материалы экспертных обзоров, разделы прайс-листов и т.п. Для того, чтобы назначить страницу первой (индексной страницей данного раздела или подраздела), укажите в поле alias «**index**».

	3. Если у вас имеется соответствующий набор прав для работы с системой, вы также увидите ниспадающее меню с именами пользователей, одного из которых вы можете отметить в качестве *автора* данного материала. Для того, чтобы изменить набор прав и разрешений для работы в системе, обратитесь, пожалуйста, к системному администратору.

6. Для создания и редактирования форматированного текста у материала может быть определено одно или несколько полей типа *HTML текст*. Поля такого типа располагаются на отдельной закладке в окне редактирования материала, на которой расположен визуальный редактор, позволяющий создавать и редактировать форматированный текст без знания HTML. Внешне редактор очень похож на текстовые редакторы семейства Microsoft Office. Приемы работы в данном редакторе также схожи с приемами работы в программах семейства Microsoft Office. Для получения более полных сведений смотрите раздел «[Работа с визуальным редактором]({{site.baseurl}}/docs/user-guide/content/vis-1.html)».

	![Редактор]({{site.baseurl}}/images/cp-3.png)

7. После того, как вы закончили работу с материалом, нажмите кнопку «Сохранить» внизу окна редактирования материала. Сохраненный материал вводится в базу данных сайта, но сразу не становится доступным для посетителей сайта и не появляется в структуре сайта. Такой подход обеспечивает функционирование системы документооборота и гарантирует проверку материалов компетентными сотрудниками компании перед публикацией материалов непосредственно на сайте.

	Если же вы имеете достаточный набор прав для публикации материалов непосредственно на сервер, вы также увидите рядом с кнопкой «Сохранить» кнопку «Сохранить и опубликовать», которая поможет вам избежать дополнительных манипуляций для публикации материала.

8. Закройте окно редактирования материала. Теперь заголовок вашего материала должен появиться в обновившемся списке материалов в окне «Материалы» интерфейса системы.

9. Если у вас имеется достаточный набор прав и разрешений для публикации материалов непосредственно на сервер, то в списке материалов их названия будут отображены черным цветом и будут доступны для выделения и редактирования. В том числе, вы сможете опубликовать материал, нажав кнопку «Опубликовать» на панели инструментов, или вернуть его в неопубликованное состояние, нажав кнопку «Отменить публикацию». Если же соответствующих разрешений и прав у вас нет, названия материалов будут отображены серым цветом, и вы не сможете производить никакие действия с ними. Публикация ваших материалов будет осуществлена после их проверки редактором/администратором сайта.

